                                org 0

Main                            proc
                                di
                                ld (RegSP),sp
                                ld sp,RegAF+2
                                push af
                                ld a,r
                                sub 7
                                and 7fh
                                ld (RegR),a
                                ld a,i
                                ld (RegI),a
                                ld (RegBC),bc
                                ld (RegDE),de
                                ld (RegHL),hl

                                ex af,af'
                                ld sp,RegAFa+2
                                push af
                                exx
                                ld (RegBCa),bc
                                ld (RegDEa),de
                                ld (RegHLa),hl
                                ld (RegIX),ix
                                ld (RegIY),iy

                                ld sp,7fffh

                                ld a,7
                                out (254),a
                                ld hl,16384
                                ld de,16385
                                ld bc,6143
                                ld (hl),0
                                ldir
                                inc hl
                                inc de
                                ld bc,767
                                ld (hl),56
                                ldir

                                ld hl,MenRegistros
                                ld de,Informe
                                ld bc,LenMsg
                                ldir

                                ld hl,PosAF
                                ld bc,(RegAF)
                                call R16toHex
                                ld hl,PosAFa
                                ld bc,(RegAFa)
                                call R16toHex
                                ld hl,PosBC
                                ld bc,(RegBC)
                                call R16toHex
                                ld hl,PosBCa
                                ld bc,(RegBCa)
                                call R16toHex
                                ld hl,PosDE
                                ld bc,(RegDE)
                                call R16toHex
                                ld hl,PosDEa
                                ld bc,(RegDEa)
                                call R16toHex
                                ld hl,PosHL
                                ld bc,(RegHL)
                                call R16toHex
                                ld hl,PosHLa
                                ld bc,(RegHLa)
                                call R16toHex
                                ld hl,PosIX
                                ld bc,(RegIX)
                                call R16toHex
                                ld hl,PosIY
                                ld bc,(RegIY)
                                call R16toHex
                                ld hl,PosSP
                                ld bc,(RegSP)
                                call R16toHex
                                ld hl,PosIR
                                ld bc,(RegIR)
                                call R16toHex

                                ld hl,MenInicial
                                call Print

                                ld hl,Informe
                                call Print

                                exx
                                ex af,af'

                                ld sp,ValRegFinal
                                ld a,0cch
                                ld i,a
                                ld r,a
                                pop af
                                ex af,af'
                                pop af
                                ex af,af'
                                pop bc
                                pop de
                                pop hl
                                exx
                                pop bc
                                pop de
                                pop hl
                                exx
                                pop ix
                                pop iy
                                ld sp,0bbbbh

                                halt
                                endp

                                ;BC= numero a convertir. HL=direccion a almacenar convertido
R16toHex                        proc
                                push de
                                ld a,b
                                call R8toHex
                                ld a,c
                                call R8toHex
                                pop de
                                ret
                                endp

                                ;A= numero a convertir. HL=direccion a almacenar convertido
R8toHex                         proc
                                ld d,a
                                srl a
                                srl a
                                srl a
                                srl a
                                and 15
                                call NibbletoHex
                                ld a,d
                                and 15
                                call NibbletoHex
                                ret
                                endp


NibbletoHex                     proc
                                ld e,'0'
                                cp 10
                                jr nc,EsLetra
                                add a,e
                                jr PonloYa
EsLetra                         ld e,'A'-10
                                add a,e
PonloYa                         ld (hl),a
                                inc hl
                                ret
                                endp

Print          proc
buc_print      ld a,(hl)
               or a
               ret z
               cp 22
               jr nz,no_at
               inc hl
               ld a,(hl)
               ld (Fila),a
               inc hl
               ld a,(hl)
               ld (Columna),a
               inc hl
               jr buc_print

no_at          cp 13
               jr nz,no_cr
               xor a
               ld (Columna),a
               ld a,(Fila)
               inc a
               ld (Fila),a
               inc hl
               jr buc_print

no_cr          cp 4
               jr nz,no_attr
               inc hl
               ld a,(hl)
               ld (Attr),a
               inc hl
               jr buc_print

no_attr        cp 32
               jr nc,imprimible
               ld a,32

imprimible     push hl
               ld hl,(Columna)
               push hl
               push af
               ld de,16384
               add hl,de
               ld a,h
               and 7
               rrca
               rrca
               rrca
               or l
               ld l,a
               ld a,248
               and h
               ld h,a
               pop af

               push hl
               ld de,Chars-256
               ld l,a
               ld h,0
               add hl,hl
               add hl,hl
               add hl,hl
               add hl,de
               pop de

               ld b,8
print_car      ld a,(hl)
;               sra a
;               or (hl)
               ld (de),a
               inc hl
               inc d
               djnz print_car
               pop hl

               push hl
               ld de,22528
               ld b,h
               ld h,0
               add hl,de
               xor a
               or b
               jr z,fin_ca_attr
               ld de,32
calc_dirat     add hl,de
               djnz calc_dirat
fin_ca_attr    ld a,(Attr)
               ld (hl),a
               pop hl

               inc l
               bit 5,l
               jr z,no_inc_fila
               res 5,l
               inc h
no_inc_fila    ld (Columna),hl
               pop hl

               inc hl
               jp buc_print

               endp

RAM            equ 6000h
Columna        equ RAM
Fila           equ Columna+1
Attr           equ Fila+1
RegAF          equ Attr+1
RegAFa         equ RegAF+2
RegBC          equ RegAFa+2
RegBCa         equ RegBC+2
RegDE          equ RegBCa+2
RegDEa         equ RegDE+2
RegHL          equ RegDEa+2
RegHLa         equ RegHL+2
RegIX          equ RegHLa+2
RegIY          equ RegIX+2
RegSP          equ RegIY+2
RegIR          equ RegSP+2
RegR           equ RegIR
RegI           equ RegR+1

Informe        equ RegI+1
Sig            equ Informe+LenMsg


;                                 01234567890123456789012345678901"
MenInicial     db 4,56,22,0,0,   "Z80 initial condition retriever",13
               db                "-------------------------------",0

MenRegistros   equ $
MRegistroAF    db 22,4,0,        "AF = xxxx            AF' = xxxx",13
PosAF          equ MRegistroAF+8-MenRegistros+Informe
PosAFa         equ PosAF+22
MRegistroBC    db                "BC = xxxx            BC' = xxxx",13
PosBC          equ MRegistroBC+5-MenRegistros+Informe
PosBCa         equ PosBC+22
MRegistroDE    db                "DE = xxxx            DE' = xxxx",13
PosDE          equ MRegistroDE+5-MenRegistros+Informe
PosDEa         equ PosDE+22
MRegistroHL    db                "HL = xxxx            HL' = xxxx",13
PosHL          equ MRegistroHL+5-MenRegistros+Informe
PosHLa         equ PosHL+22
MRegistroXY    db                "IX = xxxx            IY  = xxxx",13
PosIX          equ MRegistroXY+5-MenRegistros+Informe
PosIY          equ PosIX+22
MRegistroSI    db                "SP = xxxx            IR  = xxxx",13
PosSP          equ MRegistroSI+5-MenRegistros+Informe
PosIR          equ PosSP+22
MCopyR         db 22,12,0,   127,"2011 McLeod/IdeaFix. ZXProjects",0
MFin           db 0
LenMsg         equ MFin-MenRegistros

ValRegFinal    dw 1111h,2222h,3333h,4444h,5555h,6666h,7777h,8888h,9999h,0aaaah

Chars          equ $
               incbin "chars.bin"

               org 16383
               db 0
